//
//  TSAIPhotoImageCell.swift
//  AIRingtone
//
//  Created by 100Years on 2025/3/5.
//

class TSAIPhotoImageCell: TSBaseCollectionCell {
    
    lazy var showImageView: UIImageView = {
        let showImageView = UIImageView.createImageView(imageName:"",contentMode: .scaleAspectFill)
        showImageView.backgroundColor = .gray
        
        return showImageView
    }()
    
    override func creatUI() {
        contentView.addSubview(showImageView)
        showImageView.snp.makeConstraints { make in
            make.top.equalTo(0)
            make.leading.equalTo(0)
            make.trailing.bottom.equalTo(0)
        }
        
        if self.bounds.size.width == self.bounds.size.height {
            showImageView.layer.cornerRadius = self.bounds.size.width/2
        }else{
            showImageView.layer.cornerRadius = 16
        }
        
    }
    
    override func renderView(with object: Any?, component: TSCollectionViewComponent, attributes: [String : Any]?) {
        super.renderView(with: object, component: component, attributes: attributes)
        if let itemModel = object as? TSColVVMItemModel{
            if let generalPicModel = itemModel.dataModel as? TSActionInfoModel{
                showImageView.setAsyncImage(urlString: generalPicModel.response.resultUrl,placeholder: kPlaceholderImage,contentMode: .scaleAspectFill)
            }
        }
    }
    
}

